-- AngelPlayer: Extras
-- Some extra fluff just for me.

-- different death animation:
addHook("MobjDeath", function(mo, inf)
	if mo and mo.valid and mo.skin == "kanade"
		if not inf or not inf.valid return end	-- use regular behaviour
		-- otherwise, do the "new" death.
		mo.ap_newdeath = 1	-- used in thinkframe to check stuff.
		mo.ap_inf = inf
	end
end, MT_PLAYER)

local function AP_kanadeDeathFrame(p)
	local mo = p.mo

	if mo.ap_newdeath == 1

		P_SetObjectMomZ(mo, FRACUNIT*8)
		if mo.ap_inf and mo.ap_inf.valid
			local ang = R_PointToAngle2(mo.x, mo.y, mo.ap_inf.x, mo.ap_inf.y) + P_RandomRange(-45, 45)*ANG1
			P_InstaThrust(mo, ang, -mo.scale*4)
		end
		mo.ap_newdeath = 2
		mo.flags = $ & ~MF_NOCLIPHEIGHT
	elseif mo.ap_newdeath == 2

		if P_IsObjectOnGround(mo)
			if not P_CheckDeathPitCollide(mo)
				S_StartSound(mo, sfx_s3k5d)
				P_InstaThrust(mo, 0, 0)
				mo.ap_newdeath = 3
				mo.sprite2 = SPR2_CNT1
				mo.frame = A
				mo.anim_duration = 1
			else
				mo.flags = $ | MF_NOCLIPHEIGHT	-- fall
			end
		end
	end
end

-- I have no words for this.
-- Is this a waste of time? Yeah
-- Is this adorable? Yeah too.
local function AP_kanadeHug(p)

	if p.pflags & PF_STASIS
		local hugged
		-- scan for... hugs, I suppose?!
		-- search for blockmap for amy hug:
		searchBlockmap("objects", function(mo, found)

			if found and found.valid and found.state == S_ROSY_HUG	-- yeah that's a hug.
				hugged = found
			end
		end, p.mo)

		-- search players for the amy hug mod thingy
		if p.hugged and p.hugged.valid and p.hugged.mo and p.hugged.mo.valid	-- mandatory checks...
			hugged = p.hugged.mo
		end

		if hugged
			local mo = p.mo

			mo.ap_hugtimer = $ and $+1 or 1

			if mo.ap_hugtimer > TICRATE
				mo.sprite2 = SPR2_BLSH
				mo.frame = A	-- don't change the state, it breaks shit
			end

			if mo.ap_hugtimer >= TICRATE*3

				if mo.ap_hugtimer == TICRATE*3
					S_StartSound(mo, sfx_cdpcm6)
				end

				mo.sprite2 = SPR2_KHUG
				mo.frame = A
				p.drawangle = R_PointToAngle2(mo.x, mo.y, hugged.x, hugged.y)
			end
		end
	else
		if p.mo.ap_hugtimer
			p.mo.state = S_PLAY_STND	-- no more hugging
		end
		p.mo.ap_hugtimer = 0
	end
end

-- slower walk anim for kanade
local function AP_slowWalk(p)

	local mo = p.mo

	if mo.state == S_PLAY_WALK
		if mo.ap_prevframe ~= (mo.frame & FF_FRAMEMASK)

			if mo.tics < 3
				mo.tics = 3	-- prevent goofy fast walk
			end
			mo.ap_prevframe = (mo.frame & FF_FRAMEMASK)	-- careful with this.
		end
	end

end

-- different guard frames for kanade
local function AP_battleGuard(p)
	-- unique guard frame:
	local mo = p.mo
	if type(p.guard) == "number"	-- In case some funny mods make this into a boolean or whatever... This is too much of a generic var name :V
	and abs(p.guard) == 1
	-- implicit: p.guard == -1 (guard end?)
		mo.state = S_PLAY_STND
		mo.sprite2 = SPR2_GARD
		mo.frame = A
	end
end

rawset(_G, "AP_fluff", function(p)
	AP_kanadeDeathFrame(p)
	AP_slowWalk(p)
	AP_battleGuard(p)
	AP_kanadeHug(p)
end)