-- AngelPlayer main


-- go into mid-fall frame from spin or spin.
local function AP_midFallFrame(p)
	local mo = p.mo
	if mo.state == S_PLAY_SPRING or mo.state == S_PLAY_FALL
	or mo.state == S_PLAY_FLOATEND	-- special to CA_ANGELWINGS
	or (mo.state == S_PLAY_ROLL and not p.powers[pw_carry] and p.pflags & PF_JUMPED and ((mo.frame & FF_FRAMEMASK) == C))

		local momz = mo.momz*P_MobjFlip(mo)

		if momz <= 0
		and momz >= AP_MIDFALLTHRESHOLD * mo.scale
		and mo.state ~= S_PLAY_FLOATEND	-- not applied for this state
		and not P_IsObjectOnGround(mo)	-- ERZ2 ????
			mo.state = S_PLAY_MIDFALL
		end

		if mo.state == S_PLAY_FALL
		and momz > 0
			mo.state = S_PLAY_SPRING
		end

	end

	if mo.state == S_PLAY_MIDFALL
	or mo.state == S_PLAY_FLOATEND	-- special to CA_ANGELWINGS
		local momz = mo.momz*P_MobjFlip(mo)

		local threshold = S_PLAY_MIDFALL and AP_MIDFALLTHRESHOLD or AP_MIDFALLTHRESHOLD*5/2
		-- bit of a specific case, I know...

		if momz > 0
			mo.state = S_PLAY_SPRING
		elseif momz < threshold * mo.scale
			mo.state = S_PLAY_FALL
		end
	end
end

/*
	This is where all the thinkers come together.
*/

addHook("ThinkFrame", do

	for p in players.iterate do

		if not p.mo or not p.mo.valid then continue end
		if p.mo.skin == "kanade"
			AP_midFallFrame(p)
			if srb2p
				continue
			end

			AP_overdrive(p)		-- Kanade's own unique stuff
			--AP_fluff(p)		-- Moved to PostThinkFrame to avoid mod conflicts w/ setting frame.
		end

		if p.charability == CA_ANGELWINGS
			AP_angelWings(p)
		end
		if p.charability2 == CA2_HANDSONIC
			AP_handSonic(p)
		end
	end

	if srb2p
		return
	end

	AP_serverSkewerHandler()
	AP_BattleMod()
end)

addHook("PostThinkFrame", do
	for p in players.iterate do
		if p.mo and p.mo.valid and p.mo.skin == "kanade"
			AP_fluff(p)
		end
	end
end)