-- table definitions for sliced badnik parts:

freeslot("SPR_SLCB", "SPR_SLC2", "SPR_SLC3", "MT_SLICEDPART")
mobjinfo[MT_SLICEDPART] = {
	doomednum = -1,
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	flags = MF_RUNSPAWNFUNC,
	radius = 16 << FRACBITS,
	height = 32 << FRACBITS,
}

-- fancies
addHook("MobjThinker", function(mo)

	if mo.health == 1
		return
	end

	mo.rollangle = $ + mo.extravalue1

	if leveltime %3 == 0
		for i = 1, 2
			P_SpawnMobjFromMobj(mo, P_RandomRange(-32, 32)*mo.scale, P_RandomRange(-32, 32)*mo.scale, P_RandomRange(-32, 32)*mo.scale, MT_SMOKE)
		end
	end

	if mo.fuse and mo.fuse < TICRATE/2
		if leveltime & 1
			mo.flags2 = $|MF2_DONTDRAW
		else
			mo.flags2 = $ & ~MF2_DONTDRAW
		end
	end

	if P_IsObjectOnGround(mo)
	and mo.health != 1
		mo.rollangle = 0
		mo.health = 1
		S_StartSound(mo, sfx_cybdth)
		mo.state = S_MINE_BOOM1
		mo.flags = MF_NOGRAVITY|MF_NOBLOCKMAP
		mo.momx, mo.momy, mo.momz = 0, 0, 0
		return
	end

end, MT_SLICEDPART)

addHook("MobjMoveBlocked", function(mo)
	if mo.health != 1
		mo.rollangle = 0
		mo.health = 1
		S_StartSound(mo, sfx_cybdth)
		mo.state = S_MINE_BOOM1
		mo.flags = MF_NOGRAVITY|MF_NOBLOCKMAP
		mo.momx, mo.momy, mo.momz = 0, 0, 0
		return
	end
end, MT_SLICEDPART)

rawset(_G, "AP_slicedBadniks", {

	[-1] =				{SPR_SLC3, A, B},	-- monitors

	[MT_BLUECRAWLA] = 	{SPR_SLCB, A, B},
	[MT_REDCRAWLA] = 	{SPR_SLCB, C, D},

	[MT_GFZFISH] = 		{SPR_SLCB, E, F},

	[MT_SNAILER] =		{SPR_SLCB, G, H},

	[MT_GOLDBUZZ] =		{SPR_SLCB, I, J},
	[MT_REDBUZZ] =		{SPR_SLCB, K, L},

	[MT_JETJAW]	=		{SPR_SLCB, M, N},

	[MT_SPRINGSHELL] =	{SPR_SLCB, O, P},
	[MT_YELLOWSHELL] =	{SPR_SLCB, Q, R},

	[MT_CRUSHSTACEAN] =	{SPR_SLCB, S, T},

	[MT_ROBOHOOD] =		{SPR_SLCB, U, V},

	[MT_EGGSHIELD] =	{SPR_SLCB, W, X},
	[MT_EGGGUARD] =		{SPR_SLCB, Y, Z},

	[MT_JETTBOMBER] =	{SPR_SLC2, A, B},
	[MT_JETTGUNNER] =	{SPR_SLC2, C, D},

	[MT_VULTURE] =		{SPR_SLC2, E, F},

	[MT_MINUS] =		{SPR_SLC2, G, H},

	[MT_UNIDUS] =		{SPR_SLC2, I, J},

	[MT_PENGUINATOR]=	{SPR_SLC2, K, L},
	[MT_POPHAT] =		{SPR_SLC2, M, N},

	[MT_SPINCUSHION] =	{SPR_SLC2, O, P},

	[MT_CACOLANTERN] =	{SPR_SLC2, Q, R},

	[MT_BANPYURA] = 	{SPR_SLC2, S, T},

	[MT_HANGSTER] =		{SPR_SLC2, U, V},

	[MT_PTERABYTE] =	{SPR_SLC2, W, X},
	[MT_PYREFLY] =		{SPR_SLC2, Y, Z},
})

rawset(_G, "AP_sliceBadnik", function(mo, source)

	if mo.flags & MF_BOXICON return end	-- wtf
	if mo.ap_sliced return end	-- you should be dead.

	mo.ap_sliced = true
	if source.player and source.player.valid
	and not (mo.flags & (MF_MONITOR|MF_GRENADEBOUNCE) == MF_MONITOR|MF_GRENADEBOUNCE)	-- no gold box cheese
		AP_addOverdrive(source.player)	-- give overdrive here
	end

	if AP_slicedBadniks[mo.type]
	or mo.flags & (MF_MONITOR|MF_GRENADEBOUNCE) == MF_MONITOR	-- very specific check, I know, but we don't want golden monitors.
		local tbl = AP_slicedBadniks[mo.type]

		if mo.flags & (MF_MONITOR|MF_GRENADEBOUNCE) == MF_MONITOR
			tbl = AP_slicedBadniks[-1]
			mo.flags2 = $|MF2_DONTDRAW	-- goodbye

			if mo.ap_ogposition
				P_TeleportMove(mo, mo.ap_ogposition[1], mo.ap_ogposition[2], mo.ap_ogposition[3])
			end
		end

		for i = 1, 2

			local t = P_SpawnMobjFromMobj(mo, 0, 0, mo.scale*2, MT_SLICEDPART)
			t.tics = -1
			t.fuse = TICRATE*2
			t.sprite = tbl[1]
			t.frame = tbl[1+i]
			t.extravalue1 = P_RandomRange(8, 20)*(P_RandomRange(0, 1) and -1 or 1) *ANG1
			t.eflags = $ | (mo.eflags & MFE_VERTICALFLIP)

			local spd = R_PointToDist2(0, 0, source.momx, source.momy)
			local ang = R_PointToAngle2(0, 0, source.momx, source.momy)

			ang = $ + P_RandomRange(-60, 60)*ANG1
			P_InstaThrust(t, ang, spd*3/4)
			t.momz = P_RandomRange(4, 12)*P_MobjFlip(mo) * mo.scale
		end
	end
end)